<?php namespace Api\Lib\Platform;
use Dever;
class Request
{
    public function __construct($field, $platform_id, $type, $type_id)
    {
        $this->field = $field;
        $this->platform_id = $platform_id;
        $this->type = $type;
        $this->type_id = $type_id;
    }

    public function body()
    {
        $body = array();
        $this->load($body, 'body');
        $this->field->setBody($body);
        $this->field->setBodyJson($body ? Dever::json_encode($body) : '');
        return $body;
    }

    public function header()
    {
        $header = array();
        $this->load($header, 'header');
        $this->field->setHeader($header);
        return $header;
    }

    protected function load(&$data, $table)
    {
        $this->get($data, 'platform_request_' . $table, array('platform_id' => $this->platform_id));
        $this->get($data, $this->type . '_request_' . $table, array($this->type . '_id' => $this->type_id));
    }

    protected function get(&$data, $table, $where)
    {
        $request = Dever::db($table, 'api')->select($where);
        if ($request) {
            foreach ($request as $k => $v) {
                $value = $this->field->value($v['value'], $v['type']);
                if ($value) {
                    if (strstr($v['key'], '.')) {
                        $keys = explode('.', $v['key']);
                        $temp = &$data;
                        foreach ($keys as $key) {
                            $temp = &$temp[$key];
                        }
                        $temp = $value;
                    } else {
                        $data[$v['key']] = $value;
                    }
                    $this->field->set($v['key'], $value);
                }
            }
        }
    }
}